// HexachordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.






// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;



public class HexachordTableFrame extends JFrame
                                 implements ScrollPaneConstants {

	static final int xOffset = 190, yOffset = 280;
	static int openFrameCount = 0;

	JPanel hexachordListPanel;





	public HexachordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector", 
					"M7/M7I",
					"Symmetry",
					"Combinatoriality"};

		TnTnIType hexachordList = new TnTnIType();
		final JTable table = new JTable(hexachordList.listPrime(6), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(500, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table,
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel hexachordListPanel = new JPanel(new GridLayout(1, 0));
		hexachordListPanel.add(scrollPane);
		getContentPane().add(hexachordListPanel, BorderLayout.CENTER);
		setSize(570,400);
		openFrameCount++;
		setTitle("Tn/TnI Hexachords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
