// NonachordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;



public class NonachordTableFrame extends JFrame
                                 implements ScrollPaneConstants {

	static final int xOffset = 250, yOffset = 340;
	static int openFrameCount = 0;

	JPanel nonachordListPanel;





	public NonachordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector",
					"Symmetry"};

		TnTnIType nonachordList = new TnTnIType();
		final JTable table = new JTable(nonachordList.listPrime(9), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(500, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table,
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel nonachordListPanel = new JPanel(new GridLayout(1, 0));
		nonachordListPanel.add(scrollPane);
		getContentPane().add(nonachordListPanel, BorderLayout.CENTER);
		setSize(430,250);
		openFrameCount++;
		setTitle("Tn/TnI Nonachords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
