// PentachordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class PentachordTableFrame extends JFrame
                                  implements ScrollPaneConstants {

	static final int xOffset = 170, yOffset = 260;
	static int openFrameCount = 0;

	JPanel pentachordListPanel;





	public PentachordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector", 
					"M7/M7I",
					"Symmetry"};

		TnTnIType pentachordList = new TnTnIType();
		final JTable table = new JTable(pentachordList.listPrime(5), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(500, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table,
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel pentachordListPanel = new JPanel(new GridLayout(1, 0));
		pentachordListPanel.add(scrollPane);
		getContentPane().add(pentachordListPanel, BorderLayout.CENTER);
		setSize(450,350);
		openFrameCount++;
		setTitle("Tn/TnI Pentachords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
