// SeptachordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;



public class SeptachordTableFrame extends JFrame
                                  implements ScrollPaneConstants {

	static final int xOffset = 210, yOffset = 300;
	static int openFrameCount = 0;

	JPanel septachordListPanel;





	public SeptachordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector",
					"Symmetry"};

		TnTnIType septachordList = new TnTnIType();
		final JTable table = new JTable(septachordList.listPrime(7), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(300, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table,
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel septachordListPanel = new JPanel(new GridLayout(1, 0));
		septachordListPanel.add(scrollPane);
		getContentPane().add(septachordListPanel, BorderLayout.CENTER);
		setSize(390,350);
		openFrameCount++;
		setTitle("Tn/TnI Septachords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
