// TetrachordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class TetrachordTableFrame extends JFrame
                                  implements ScrollPaneConstants {

	static final int xOffset = 150, yOffset = 240;
	static int openFrameCount = 0;

	JPanel tetrachordListPanel;





	public TetrachordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector", 
					"M7/M7I",
					"Symmetry"};

		TnTnIType tetrachordList = new TnTnIType();
		final JTable table = new JTable(tetrachordList.listPrime(4), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(500, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table,
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel tetrachordListPanel = new JPanel(new GridLayout(1, 0));
		tetrachordListPanel.add(scrollPane);
		getContentPane().add(tetrachordListPanel, BorderLayout.CENTER);
		setSize(450,300);
		openFrameCount++;
		setTitle("Tn/TnI Tetrachords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
