// TrichordTableFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2010 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.io.*;
import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class TrichordTableFrame extends JFrame
                                implements ScrollPaneConstants {

	static final int xOffset = 130, yOffset = 220;
	static int openFrameCount = 0;





	public TrichordTableFrame() {

		String[] columnNames = {"Forte Name", 
					"Tn/TnI", 
					"I-Vector", 
					"M7/M7I",
					"Symmetry"};

		TnTnIType trichordList = new TnTnIType();
		final JTable table = new JTable(trichordList.listPrime(3), 
						columnNames);
		table.setBackground(Color.white);
		table.setPreferredScrollableViewportSize(
			new Dimension(200, 70));
		table.setDragEnabled(true);
		table.setCellSelectionEnabled(true);

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane = new JScrollPane(
			table, 
			VERTICAL_SCROLLBAR_AS_NEEDED,
			HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel trichordListPanel = new JPanel(new GridLayout(1, 0));
		trichordListPanel.add(scrollPane);
		getContentPane().add(trichordListPanel, BorderLayout.CENTER);
		setSize(450,250);
		openFrameCount++;
		setTitle("Tn/TnI Trichords " + openFrameCount);
		setLocation(xOffset + (20 * openFrameCount), 
			    yOffset + (20 * openFrameCount));
	}
}
