// TritoneSensitiveFrame.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.




import java.io.*;
import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class TritoneSensitiveFrame extends JInternalFrame
                               implements ScrollPaneConstants {

	static final int xOffset = 20, yOffset = 20;
	static int openFrameCount = 0;


	public TritoneSensitiveFrame() {

		super("List of Tritone Sensitivity #" + (++openFrameCount), 
		      true, //resizable
		      true, //closable
		      true, //maximizable
		      true);//iconifiable

		String[] columnNames = {"Name", 
					"Tn/TnI", 
					"IC-Vector", 
					"M7"};

		TnTnIType tritoneSensitiveFrame = new TnTnIType();
		final JTable table 
			= new JTable(tritoneSensitiveFrame.listPrime(3), 
						columnNames);
		table.setPreferredScrollableViewportSize(
			new Dimension(500, 70));

		//Create the scroll pane and add the table to it.
		JScrollPane scrollPane 
			= new JScrollPane(table, 
					  VERTICAL_SCROLLBAR_AS_NEEDED,
					  HORIZONTAL_SCROLLBAR_AS_NEEDED);

		//...Create the GUI and put it in the window...
		JPanel tritoneSensitiveFramePanel 
			= new JPanel(new GridLayout(1, 0));
		tritoneSensitiveFramePanel.add(scrollPane);
		getContentPane().add(
			tritoneSensitiveFramePanel, BorderLayout.CENTER);
		setSize(400,300);
		setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
	}
}
