// TritoneSensitiveList.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2010 Akira Takaoka
// All rights reserved.





import java.io.*;

public class TritoneSensitiveList extends TnIType {



	// Initialize Set objects with 
	// Forte names, Tn/TnI type, i-vectors, and M7.
	private void initPrime3() {

		for(int i = 0; i < 12; i++) {
			prime3[i] = new Set(3);
		}

		prime3[0].name = "3-1";
		prime3[1].name = "3-2";
		prime3[2].name = "3-3";
		prime3[3].name = "3-4";
		prime3[4].name = "3-5";
		prime3[5].name = "3-6";
		prime3[6].name = "3-7";
		prime3[7].name = "3-8";
		prime3[8].name = "3-9";
		prime3[9].name = "3-10";
		prime3[10].name = "3-11";
		prime3[11].name = "3-12";

	prime3[0].set = new int[] {0,1,2};
	prime3[1].set = new int[] {0,1,3};
	prime3[2].set = new int[] {0,1,4};
	prime3[3].set = new int[] {0,1,5};
	prime3[4].set = new int[] {0,1,6};
	prime3[5].set = new int[] {0,2,4};
	prime3[6].set = new int[] {0,2,5};
	prime3[7].set = new int[] {0,2,6};
	prime3[8].set = new int[] {0,2,7};
	prime3[9].set = new int[] {0,3,6};
	prime3[10].set = new int[] {0,3,7};
	prime3[11].set = new int[] {0,4,8};

	prime3[0].ivector = new int[] {2,1,0,0,0,0};
	prime3[1].ivector = new int[] {1,1,1,0,0,0};
	prime3[2].ivector = new int[] {1,0,1,1,0,0};
	prime3[3].ivector = new int[] {1,0,0,1,1,0};
	prime3[4].ivector = new int[] {1,0,0,0,1,1};
	prime3[5].ivector = new int[] {0,2,0,1,0,0};
	prime3[6].ivector = new int[] {0,1,1,0,1,0};
	prime3[7].ivector = new int[] {0,1,0,1,0,1};
	prime3[8].ivector = new int[] {0,1,0,0,2,0};
	prime3[9].ivector = new int[] {0,0,2,0,0,1};
	prime3[10].ivector = new int[] {0,0,1,1,1,0};
	prime3[11].ivector = new int[] {0,0,0,3,0,0};

	prime3[0].m7set = new int[] {0,2,7};
	prime3[1].m7set = new int[] {0,2,5};
	prime3[2].m7set = new int[] {0,3,7};
	prime3[3].m7set = new int[] {0,1,5};
	prime3[4].m7set = new int[] {0,1,6};
	prime3[5].m7set = new int[] {0,2,4};
	prime3[6].m7set = new int[] {0,1,3};
	prime3[7].m7set = new int[] {0,2,6};
	prime3[8].m7set = new int[] {0,1,2};
	prime3[9].m7set = new int[] {0,3,6};
	prime3[10].m7set = new int[] {0,1,4};
	prime3[11].m7set = new int[] {0,4,8};
    }



	public int[] getTnTnIType(int[] tntype) {
		return tnOrTnIType(tntype, getTnIType(tntype));
	}

}

